#!/usr/bin/env python

import sys
import os
import numpy as np
import matplotlib.pyplot as plt
from os import listdir
from os.path import isfile, join

def weakscaling(logdir,title_name):
    p = 1
    pmax = 1
    nfiles = 1
    i = 1
    x = range(8)
    time = np.zeros(8)
    err = np.zeros(8)
    steps = ['Alloc','Sort','Step #1','Step #2',
             'Step #3H','Step #3','Eval','TOTAL']
    colors = ['r','b','g','c','m','y','k','w']
    labels = []
    allfiles = [f for f in listdir(logdir) if isfile(join(logdir, f))]
    #while i <= pmax:
    for filename in  allfiles:
        name = logdir + filename
       # name = logdir + "random100000.log"
        try:
            log1 = open(name,'r')
        except:
            print("failed opening file: " + name)
            i += 1
            continue
        
        print name
        t = np.zeros((i,8))
        for line in log1:
            try:
                r = int(line.split(', ')[0].split('rank ')[1])
                step = line.split(': ')[0].split(', ')[1]
                s = steps.index(step)
                t[r,s] = float(line.split(': ')[1])
            except:
                continue

        for j in range(i):
            total = sum(t[j,:])
            t[j,7] = total
        
        avt = np.zeros(8)
        for j in range(8):
            avt[j] = np.mean(t[:,j])
        time = np.vstack((time,avt))

        stdt = np.zeros(8)
        for j in range(8):
            stdt[j] = np.std(t[:,j])
        err = np.vstack((err,stdt))
        
        labels.append('p'+str(i))
        i += 1
        nfiles += 1
      #  break

#    print('time:')
#    print time
    
    dx = 1./(nfiles+1)
    offset = np.arange(-0.5,0.5,dx)

    plt.figure()
    for i in range(nfiles-1):
        fig = plt.bar(x+offset[i],time[i+1,:],width=dx,color=colors[i%8],label=allfiles[i])
  #  plt.yscale('log')
    plt.xticks(x,steps,rotation='vertical')
    plt.title('CPU time, 100k points ' + title_name)
    plt.xlabel('Subroutine')
    plt.ylabel('CPU Time (s)')
    plt.legend(labels,loc='best')
    plt.tight_layout()
    plt.legend(loc='best')
    plt.savefig('weakscaling.png')
 #   plt.show()


    return
    

def main():
    #file = sys.argv[1]
    
    weakscaling("./experiments/paramsweep/results/bench/","defult")
    weakscaling("./experiments/paramsweep/results/bench2/","new")
   # weakscaling("./experiments/paramsweep/results/spiral100000-T=lin(min=0,max=0.8,nsteps=16)-nprocs=4/logs/","new")
    plt.show()
    
if __name__ == "__main__":
    sys.exit(main())
 
