/* These are the evaluation kernels, the following uses texturefetch but
 * might be better off reading directly from the input arrays.
 * Here should also the mpexp kernels be placed.
 *
 * Note: these kernels are not well written and does not calculate the correct
 * result, but atleast they can read the points and calculate things on the GPU.
 */
#include "math_functions.h" //Cuda math functions
// -------Kernel functions--------
// eval at zx,zy,zz motsvarar rinv i direct.c
__global__ 
void kernelType1(double *gpuPr, int N) {
  int i = blockDim.x * blockIdx.x + threadIdx.x;
  if ( i < N ) {
    for ( int j=1; j < N; j++ ) {
      double x1,x2,y1,y2,z1,z2,mm1,mm2;
      TEXTUREFETCH(x1,tzx,i);
      TEXTUREFETCH(x2,tzx,j);
      TEXTUREFETCH(y1,tzy,i);
      TEXTUREFETCH(y2,tzy,j);
      TEXTUREFETCH(z1,tzz,i);
      TEXTUREFETCH(z2,tzz,j);
      double dx = x2 - x1;
      double dy = y2 - y1;
      double dz = z2 - z1;
      double distSqr = dx*dx + dy*dy + dz*dz;
      double invDist = rsqrt(distSqr);
      TEXTUREFETCH(mm1,tmm,j);
      TEXTUREFETCH(mm2,tmm,i);

      gpuPr[i] += mm1*invDist;
      gpuPr[j] += mm2*invDist;
    }
  }
}

// eval at ex,ey,ez motsvarar rinv2 
__global__ 
void kernelType2(double *gpuQr, int N,int NE) {

  int i = blockDim.x * blockIdx.x + threadIdx.x;
  if ( i < NE ) {
    for ( int j=0; j < NE; j++ ) {
      double x1,x2,y1,y2,z1,z2,mm1;
      TEXTUREFETCH(x1,tzx,i);
      TEXTUREFETCH(x2,tex,j);
      TEXTUREFETCH(y1,tzy,i);
      TEXTUREFETCH(y2,tey,j);
      TEXTUREFETCH(z1,tzz,i);
      TEXTUREFETCH(z2,tez,j);
      double dx = x2-x1;
      double dy = y2-y1;
      double dz = z2-z1;
      double distSqr = dx*dx + dy*dy + dz*dz;
      double invDist = rsqrt(distSqr);
      TEXTUREFETCH(mm1,tmm,j);

      gpuQr[i] += mm1*invDist;

    }
  }
}


