/* direct.cpp */

/* 2015-04-22 - J. Westberg
   Introduced a .cpp to act between .c files and .cu files.
   Uses the same header direct.h and compiling direct.cpp gives gpu version
   while compiling direct.c gives the CPU version.
*/
 #include "direct.h" 
/*------------------------------------------------------------------------*/
void directInteract(int N,
        const double *restrict zx,const double *restrict zy,const double *restrict zz,
		    const double *restrict mm,
		    int NE,
        const double *restrict ex,const double *restrict ey,const double *restrict ez,
        double *pr,
        double *qr,
        int pot,
		    enum SMOOTHER smooth)

{
  // evaluation at (ex,ey,ez) calling a CUDA function
    direct_eval_cuda(N,zx,zy,zz,mm,NE,ex,ey,ez,pr,qr,
		     pot,smooth);
}
/*------------------------------------------------------------------------*/
// TODO: remove mpexp_ part of name
void mpexp_directInteract2(double *pr,
			   const double *restrict zx,const double *restrict zy,const double *restrict zz,
			   const double *restrict mm,
			   const int *restrict ix,
			   int begin1,int end1,int begin2,int end2,
			   int pot,enum SMOOTHER smooth)
{
    // evaluation at (zx,zy,zz) calling a CUDA function
  mpexp_direct_interact_cuda2(pr,zx,zy,zz,mm,ix,
         begin1,end1,begin2,end2,pot,smooth);
}
/*------------------------------------------------------------------------*/
void mpexp_directInteract(double *qr,
			  const double *restrict ex,const double *restrict ey,const double *restrict ez,
			  const int *restrict jx,int begin1,int end1,
			  const double *restrict zx,const double *restrict zy,const double *restrict zz,
			  const double *restrict mm,
			  const int *restrict ix,int begin2,int end2,
			  int pot,enum SMOOTHER smooth)
{
    // evaluation at (ex,ey,ez) calling a CUDA function
  mpexp_direct_interact_cuda(qr,ex,ey,ez,jx,
        begin1,end1,zx,zy,zz,mm,ix,begin2,end2,pot,smooth);
}
/*------------------------------------------------------------------------*/
