/* direct.h */

/* S. Engblom 2007-07-08 (Revision) */
/* S. Engblom 2007-06-26 */

#ifndef __direct_h
#define __direct_h

#include "fmm.h"

#ifdef CUDASUPPORT
#include "cudaeval.h"
#endif
/* Direct evaluation of the potential from N pointmasses (m) at
   the positions (zx,zy,zz). */
#ifdef __cplusplus   
extern "C"{
#endif
void directInteract(int N,
		    const double *restrict zx,const double *restrict zy,const double *restrict zz,
		    const double *restrict mm,
		    int NE,
		    const double *restrict ex,const double *restrict ey,const double *restrict ez,
		    double *pr,double *qr,
		    int pot,
		    SMOOTHER smooth);

void mpexp_directInteract2(double *pr,
			   const double *restrict zx,const double *restrict zy,const double *restrict zz,
			   const double *restrict mm,
			   const int *restrict ix,
			   int begin1,int end1,int begin2,int end2,
			   int pot,SMOOTHER smooth);

void mpexp_directInteract(double *qr,
			  const double *restrict ex,const double *restrict ey,const double *restrict ez,
			  const int *restrict jx,int begin1,int end1,
			  const double *restrict zx,const double *restrict zy,const double *restrict zz,
			  const double *restrict mm,
			  const int *restrict ix,int begin2,int end2,
			  int pot,SMOOTHER smooth);

#ifdef FMM_MPI
void mpexp_directInteractHalo(double *pr,
			  const double *restrict zx,const double *restrict zy,const double *restrict zz,
			  const int *restrict ix,int begin1,int end1,
			  const double *restrict recvlptr,
			  int begin2,int end2,
			  int pot,SMOOTHER smooth,int rank);
#endif

#ifdef __cplusplus		    
}
#endif
#endif /* __direct_h */
