/* io.h */

/* J. Bull 2015-11-16 */

#ifndef __io_h
#define __io_h

#include "fmm.h"

#ifdef FMM_MPI
#include "mpi.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <getopt.h>
#include <sys/stat.h>
#include <string>
#include <sstream>
#include <iostream>
#include <fstream>

// read MATLAB, numpy or VTK formatted data
void ReadInput(int nprocs,int rank, 
	       int argc, char *const *argv, 
	       char **output_file, int *N, int *NE,
               double **zx,double **zy,double **zz,double **mm,
               double **ex,double **ey,double **ez,
               double *tol,int *pot,int *Ndirect,int *pcoeff,
               int *Nlevels,int *out,
               SMOOTHER *smooth,double *eta,double *theta);

// write mesh to file
#ifndef NOMEX
void WriteMesh(int rank, int out, char *output_file, int N, int NE,
                 int Nlevels,int nprocs,
                 mxArray *m, mxArray *c, mxArray *h,mxArray *s,mxArray *t);
#endif
// write potentials to file
void WritePotential(int rank, int out, char *output_file, int N, int NE,
                 int Nlevels,int nprocs,
                 const double *pr,const double *qr);

#endif /* __io_h */
