function generate_random_cartesian_cube(N,power)
% make a cube of sub-cubes, each containing N random points.
% subcubes follow Cartesian ordering.
rand('state',131345);
%power=1;
dim=power;
P=dim^3
base=strcat('examples/random_cart_',int2str(N*P/1000),'k_p',int2str(P),'/')
% uncomment next 2 lines for strong scaling tests
%base=strcat('examples/random_cart_',int2str(N/1000),'k_p',int2str(P),'/')
%N = (N/P)
mkdir(base);

xx = rand(N,1);
yy = rand(N,1);
zz = rand(N,1);
m = rand(N,1);

if(P==1),
    z=cat(2,xx,yy,zz);
    save(strcat(base,'z',int2str(N),'_0.mat'),'z');
    save(strcat(base,'m',int2str(N),'_0.mat'),'m');
else
    ind=1;
    for i=1:dim,
        for j=1:dim,
            for k=1:dim,
                z=cat(2,xx+i-1,yy+j-1,zz+k-1);
                save(strcat(base,'z',int2str(N),'_',int2str(ind-1),'.mat'),'z');
                clear z;
                save(strcat(base,'m',int2str(N),'_',int2str(ind-1),'.mat'),'m');
                ind=ind+1;
            end
        end
    end
end

basez=strcat(base,'z',int2str(N));
basem=strcat(base,'m',int2str(N));
if(P==1)
    basez=strcat(basez,'_0');
    basem=strcat(basem,'_0');
end
matfiletobin(basez,P);
delete(strcat(basez,'*.mat'));
matfiletobin(basem,P);
delete(strcat(basem,'*.mat'));

